'use strict';

exports.__esModule = true;

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (mapStateToProps, mapDispatchToProps) {
  return function (wrappedComponent) {
    return _vue2.default.component('Connect', {
      render: function render(createElement) {
        return createElement(wrappedComponent, {
          props: Object.assign({}, this.stateProps, this.dispatchProps)
        });
      },
      props: ['store'],
      data: function data() {
        return {
          dummy: false,
          stateProps: {},
          dispatchProps: {}
        };
      },
      methods: {
        update: function update() {
          if (mapStateToProps) {
            if (typeof mapStateToProps !== "function") console.error("mapStateToProps is not a function!");else {
              var newStateProps = mapStateToProps(this.store.getState());
              // prevent component update if state props didn't change.
              var componentShouldUpdate = JSON.stringify(newStateProps) !== JSON.stringify(this.stateProps);
              if (componentShouldUpdate) {
                this.stateProps = newStateProps;
              }
            }
          }
        }
      },
      created: function created() {
        var _this = this;

        if (mapDispatchToProps) {
          if (typeof mapDispatchToProps !== "function") console.error("mapDispatchToProps is not a function!");else this.dispatchProps = mapDispatchToProps(this.store.dispatch);
        }
        this.update();
        this.store.subscribe(function () {
          return _this.update();
        });
      }
    });
  };
};